/*
 * Each node broadcasts a message of type 2 and toggles its LED0 periodically.
 * Upon receiving a message of type 2, LED1 is toggled.
 */
#include <motelib/system.h>
#include <motelib/led.h>
#include <motelib/timer.h>
#include <motelib/radio.h>
#include <motelib/button.h>


#define RESPOND 12
#define REQ 11
#define decline 0
#define accept 1

Timer t;
int statusFlag;

void recv(Address source, MessageType type, void* msg, uint8_t len)
{
	char secureWord = ((char *)msg)[0];
	if(type == REQ && secureWord == 'b'){
		ledSetValue(7);
		statusFlag = accept;
	}
}

//void sendDone(RadioStatus t)
//{
//}

void button(ButtonStatus s){
	if (s == BUTTON_PRESSED && statusFlag == accept){
    	radioRequestTx(BROADCAST_ADDR, RESPOND, "a", 1, NULL);
	}
}

void timerFired(Timer *t)
{
	ledSetValue(0);
	statusFlag = decline;
}

void boot()
{
	ledSetValue(0);
	statusFlag = decline;
    timerCreate(&t);
    timerStart(&t, TIMER_PERIODIC, 10000, timerFired);
    radioSetRxHandler(recv);
	buttonSetHandler(button);
}
